// "Hello, World!" Demo v1.1
// Made possible by Alberto Covarrubias' Cursor Demo source code.
// (Not to mention his VB C compiler and Virtual Environment programs...)
// Copyright (c) Amos Bieler 2002 <abieler@gmx.net>

/*////////////////////////////
// Changes ///////////////////
//////////////////////////////

The first VB demo (AFAIK) that uses Objects!

Plus, it animates each object individually!

Modified the default headers (again ;) to include some Object handling stuff.

(BTW, I'll never modify the headers in such a way that it breaks old programs,
so, don't worry about overwriting the original ones.)

Removed the cumbersome "Init" function...

*/////////////////////////////

/*////////////////////////////
// To Do /////////////////////
//////////////////////////////

Add warning/alignment screens (and, maybe, a "Press Start!")

Add DogP's rnd functions and make the spinning less "spirally."

*/////////////////////////////

#include "vbaddr.h"	// It _was_ useful! Thanks, Alberto!  But, I think I made it more so...
//#include "vbtypes.h"	// This header is already included by vbhw.h
#include "vbhw.h"	// This header contains prototypes for the default library

/*////////////////////////////
// Data //////////////////////
////////////////////////////*/

// This static HWORD array is the "font," such as it is ;)
// As you can see, it is, appropriately, called chFont.
static HWORD chFont[] = {
	0x3C0F, 0x3C0F, 0x3C0F, 0x3FFF, 0x3C0F, 0x3C0F, 0x3C0F, 0x0000, // H
	0x3FFF, 0x000F, 0x000F, 0x00FF, 0x000F, 0x000F, 0x3FFF, 0x0000, // E
	0x000F, 0x000F, 0x000F, 0x000F, 0x000F, 0x000F, 0x3FFF, 0x0000, // L
	0x0FFC, 0x3C0F, 0x3C0F, 0x3C0F, 0x3C0F, 0x3C0F, 0x0FFC, 0x0000, // O
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000F, 0x000D, 0x0003, // , 
	0x380B, 0x380B, 0x3C0F, 0x2E2E, 0x2EEE, 0x0FFC, 0x0F3C, 0x0000, // W
	0x0FFF, 0x3C0F, 0x3C0F, 0x3C0F, 0x0FFF, 0x0F0F, 0x3C0F, 0x0000, // R
	0x0FFF, 0x3C0F, 0x3C0F, 0x3C0F, 0x3C0F, 0x3C0F, 0x0FFF, 0x0000, // D
	0x2800, 0x3F00, 0x2F80, 0x0BC0, 0x00F0, 0x0020, 0x000F, 0x000F	// !
};

// This one is the "BGMap" that spells out the message using chars from chFont.
//static int bgMessage[] = {0, 1, 2, 2, 3, 4, 5, 3, 6, 2, 7, 8};	// HELLO, WORLD!

// This is a set of objects that spells out the message using chars from chFont.
static HWORD objMessage[] = {
//	X		L/RON & P	Y		Pal/HFlp/VFlp/Char
	144,	0xC000,		108,	0,	// "H"
	152,	0xC000,		108,	1,	// "E"
	160,	0xC000,		108,	2,	// "L"
	168,	0xC000,		108,	2,	// "L"
	176,	0xC000,		108,	3,	// "O"
	184,	0xC000,		108,	4,	// ","
	192,	0xC000,		108,	5,	// "W"
	200,	0xC000,		108,	3,	// "O"
	208,	0xC000,		108,	6,	// "R"
	216,	0xC000,		108,	2,	// "L"
	224,	0xC000,		108,	7,	// "D"
	232,	0xC000,		108,	8	// "!"
};

// This one is the P and Y coordinates for the circle animation.
static int Circle[] = {
0, 108, 0, 109, 1, 110, 1, 111, 2, 112, 3, 111, 3, 110, 4, 109,
4, 108, 4, 107, 3, 106, 3, 105, 2, 104, 1, 105, 1, 106, 0, 107};

/*////////////////////////////
// Functions /////////////////
////////////////////////////*/

// The compiler only accepts a void main() without arguments.
void main ()
{
	HWORD count, points[12];	// The current coordinates for each Object (for animation.)

	vbReset ();	// Reset the VB (not sure exactly what this entails, 
				// but it sets up the column tables, at least.)

	// Set up the video hardware so the screen doesn't display the random, uninitialized VRAM:
	VIP_REGS (BRTA)  = 0;	// Set the brightness registers to 0 (Black.)
	VIP_REGS (BRTB)  = 0;
	VIP_REGS (BRTC)  = 0;
	VIP_REGS (GPLT0) = 0xE4;	// Set all eight palettes to: 11, 10, 01, 00
	VIP_REGS (GPLT1) = 0xE4;	// (i.e. "Normal" dark to light progression.)
	VIP_REGS (GPLT2) = 0xE4;
	VIP_REGS (GPLT3) = 0xE4;
	VIP_REGS (JPLT0) = 0xE4;
	VIP_REGS (JPLT1) = 0xE4;
	VIP_REGS (JPLT2) = 0xE4;
	VIP_REGS (JPLT3) = 0xE4;
	VIP_REGS (BKCOL) = 0;	// Clear the screen to black before rendering

	// Copy the font chars into the char table.
	// This routine from the default library is very useful!
	//                                          ~~~~

	// memcpy(destination address, source address, number of bytes)
	memcpy ((void*)CharSeg0, (void*)chFont, 144);

	// Copy the message objects into OAM (Object Attribute Memory.)
	memcpy ((void*)ObjectSeg, (void*)objMessage, 96);

	// Set up the first world (31) to hold our Objects.
	// Set up the second world (30) to be the End world.  It and all others are not drawn.
	// (Using another handy routine from the default library...)

	// See vbaddr.h for the constants from which to build a world header (WRLD_*)
	// Just OR them together like I did with LON and RON below.

	// vbSetWorld (World, Header, GX, GP, GY, MX, MP, MY, Width, Height)
	vbSetWorld (31, (WRLD_LON|WRLD_RON|WRLD_OBJ), 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld (30, WRLD_END, 0, 0, 0, 0, 0, 0, 0, 0);

	// Set the first SPT pointer (SPT3) to point to the first 12 Objects
	VIP_REGS (SPT3) = 11;
	VIP_REGS (SPT2) = 0;
	VIP_REGS (SPT1) = 0;
	VIP_REGS (SPT0) = 0;

	// Setup the 12 Object coordinates for the animation
	for(count = 0; count < 12; count++) points[count] = count;

	// Yet another "black box" function to handle the screen for us.
	vbDisplayOn ();

	// Here's one that fades in the BRT* registers from black for a nice effect.
	//vbFXFadeIn ();

	VIP_REGS (BRTA)  = 30;
	VIP_REGS (BRTB)  = 60;
	VIP_REGS (BRTC)  = 0;

//	count=0;

	while (1)
	{
	// Everything inside this infinite while loop is the animation
	// and is pretty simple when you understand what is happening
	// in the rest of the program.

		for(count=0; count < 12; count++)
		{
			if (points[count]++ > 14) points[count] -= 14;

			OBJ_PSET(count, Circle[points[count]*2])
			OBJ_YSET(count, Circle[points[count]*2+1])

//			vbMoveObject(count, count*8+144, Circle[points[count]+1], Circle[points[count]]);
		}

		vbWaitFrame (15);

	}

}
