// VB Default library
// Virtual-E (c) 2000 <virtuale98@yahoo.com>
// Coded by Alberto Covarrubias
// Modified by Amos Bieler

#ifndef _VBHW_H_
#define _VBHW_H_

#include "vbtypes.h"

HWORD vbReadPad();

//***** vbReadPad button mnemonics *****//
#define	K_RD			0x8000
#define	K_RL			0x4000
#define	K_SL			0x2000
#define	K_ST			0x1000
#define	K_LU			0x800
#define	K_LD			0x400
#define	K_LL			0x200
#define	K_LR			0x100
#define	K_RR			0x80
#define	K_RU			0x40
#define	K_TL			0x20
#define	K_TR			0x10
#define	K_B				0x8
#define	K_A				0x4
#define	LOWBATT			0x1

void vbSetColTable();
void vbReset();
void vbDisplayOn();
void vbDisplayOff();
void vbWaitFrame(int count);
void vbSetWorld(int nw, HWORD header, HWORD gx, HWORD gp, HWORD gy, HWORD mx, HWORD mp, HWORD my, HWORD width, HWORD height);

//***** vbSetWorld header flags *****// (OR these together to build a World Header)
#define	WRLD_LON	0x8000
#define	WRLD_RON	0x4000
#define	WRLD_BGMAP	0
#define	WRLD_HBIAS	0x1000
#define	WRLD_AFFINE	0x2000
#define	WRLD_OBJ	0x3000

#define	WRLD_1x1	0
#define	WRLD_1x2	0x100
#define	WRLD_1x4	0x200
#define	WRLD_1x8	0x300
#define	WRLD_2x1	0x400
#define	WRLD_2x2	0x500
#define	WRLD_2x4	0x600
#define	WRLD_4x2	0x900
#define	WRLD_4x1	0x800
#define	WRLD_8x1	0xC00

#define	WRLD_OVR	0x80
#define	WRLD_END	0x40

#endif

void vbSetObject(int num, BYTE header, int x, int p, int y, int chr);
void vbMoveObject(int num, int x, int y, int p);
void vbFXFadeIn();
void vbFXFadeOut();
void* memcpy(void* dest, const void* src, int count);
void* memset(void* dest, int c, int count);

#define OBJ_XSET(num, x)	*((PHWORD)Object(num))=x;
#define OBJ_YSET(num, y)	*((PHWORD)(Object(num)+4))=y;
#define OBJ_PSET(num, p)	*((PHWORD)(Object(num)+2))=(*((PHWORD)(Object(num)+2))&0xC000)|p;

void vbSetObject(int num, BYTE header, int x, int p, int y, int chr)
{

	HWORD temp1, temp2, signbit;

	signbit=(p&0x8000)>>2;

	temp1=(header&0xC0)<<8;
	temp2=(p&0xFF)|signbit|temp1;

	temp1=((header&0x3C)<<10)|(chr&0x7FF);

	*((PHWORD)Object(num))=x;
	*((PHWORD)(Object(num)+2))=temp2;
	*((PHWORD)(Object(num)+4))=y;
	*((PHWORD)(Object(num)+6))=temp1;

}

void vbMoveObject(int num, int x, int y, int p)
{
	HWORD rmw;

	*((PHWORD)Object(num))=x;

	rmw=*((PHWORD)(Object(num)+2))&0xC000;
	*((PHWORD)(Object(num)+2))=rmw|p;

	*((PHWORD)(Object(num)+4))=y;
}

//***** vbSetObject header flags *****// (OR these together to build an Object Header)
#define	OBJ_LON		0x80
#define	OBJ_RON		0x40

#define	OBJ_PAL0	0
#define	OBJ_PAL1	0x10
#define	OBJ_PAL2	0x20
#define	OBJ_PAL3	0x30

#define	OBJ_HFLIP	0x8
#define	OBJ_VFLIP	0x4
